unit hiStringGen;

interface

uses Windows, Share, Kol;

type
  
  ThiStringGen = class
    private
      FResult: string;
    public
      _prop_Charset: string;
      _prop_Count: integer;
      _prop_Pattern: string;
      
      _data_Count:THI_Event;
      _data_Pattern:THI_Event;
      
      _event_onResult: THI_Event;

      procedure _work_doCharset(var _Data:TData; Index:word);
      procedure _work_doGenerate(var _Data:TData; Index:word);
      procedure _work_doGenerateRnd(var _Data:TData; Index:word);
      
      procedure _var_Result(var _Data:TData; Index:word);

  end;

implementation



procedure ThiStringGen._work_doCharset;
begin
  _prop_Charset := Share.ToString(_Data);
end;


procedure ThiStringGen._work_doGenerate;
var
  Pat: string;
  C, I, L1, L2: integer;
begin
  FResult := '';
  
  C := ReadInteger(_Data, _data_Count, _prop_Count);
  Pat := ReadString(_Data, _data_Pattern, _prop_Pattern);
  
  L1 := Length(Pat);
  
  if (C > 0) and (L1 > 0) then
  begin
    L2 := C * L1;
    SetLength(FResult, L2); //      
    I := 1;
    while I <= L2 do
    begin
      Move(Pat[1], FResult[I], L1);
      Inc(I, L1);
    end;
  end;
  _hi_CreateEvent(_Data, @_event_onResult, FResult);
end;


procedure ThiStringGen._work_doGenerateRnd;
var
  C, I, L, R: integer;
begin
  FResult := '';
  
  C := ReadInteger(_Data, _data_Count, _prop_Count);
  
  L := Length(_prop_Charset);
  
  if (C > 0) and (L > 0) then
  begin
    SetLength(FResult, C); //      
    Randomize;
    for I := 1 to C do
    begin
      R := Random(L) + 1;
      FResult[I] := _prop_Charset[R];
    end;
  end;
  
  _hi_CreateEvent(_Data, @_event_onResult, FResult);
end;


procedure ThiStringGen._var_Result;
begin
  dtString(_Data, FResult);
end;



end.